package gearmanij.client;

import gearmanij.GearmanException;
import gearmanij.Packet;
import gearmanij.PacketType;

class GearmanEcho implements GearmanServerResponseHandler {

  private static final String DESCRIPTION = "GearmanEcho";
  byte [] data = null;
  boolean done = false;
  
  @Override
  public void handleResponse(Packet response) throws GearmanException {
    PacketType pt = response.getPacketType();
    if (!pt.equals(PacketType.ECHO_RES)) {
      throw new GearmanException("Dont know how to hanlde response of type " + pt);
    }
    data = response.getData();
    done = true;
  }

  @Override
  public boolean responseComplete() {
    return done;
  }
  
  public String toString () {
    return DESCRIPTION;
  }
  
  //TODO throw excpetion if called before done?
  byte [] getResults () {
    byte [] ret = new byte [0];
    if (done) {
      ret = new byte [data.length];
      System.arraycopy(data, 0, ret, 0, ret.length);
    }
    return ret;
  }

}
