package gearmanij.client;

import java.util.ArrayList;

import gearmanij.GearmanException;
import gearmanij.Packet;
import gearmanij.PacketType;
import gearmanij.util.ByteUtils;

// TODO javadoc
// TODO think long and hard about if this class is needed
public class GearmanJobStatus implements GearmanServerResponseHandler {
  private static final String DESCRIPTION = "GearmanJobStatus";
  private boolean isRunning = false;
  private boolean isKnown = false;
  private long denominator = 0;
  private long numerator = 0;
  private boolean statusRequestCompleted = false;
  
  GearmanJobStatus () {
    
  }

  public long getDenominator () {
    return denominator;
  }

  public long getNumerator () {
    return numerator;
  }
  
  // only applicable for background 
  public boolean isKnown () {
    return isKnown;
  }
  
  // Is running and is known seem to be one in the same to me.
  // For a job to be known, it must be running and not sure how 
  // a running job could be unknown
  public boolean isRunning () {
    return isRunning;
  }
  
  public void handleResponse(Packet repsonse) throws GearmanException {
    if (!repsonse.getPacketType().equals(PacketType.STATUS_RES)) {
      throw new GearmanException("Dont know how to handle response of type " + repsonse);
    }
    ArrayList<byte []> args = repsonse.getDataComponents(5);
    if (args.size() != 5) {
      throw new GearmanException("Malformed data segment. Expected 5  tokens. Only got " + args.size());
    }
    
    isKnown = (args.get(1))[0] == '0' ? false  : true; 
    isRunning = (args.get(2))[0] == '0' ? false  : true; 
    numerator = Long.parseLong(ByteUtils.fromAsciiBytes(args.get(3)));
    denominator = Long.parseLong(ByteUtils.fromAsciiBytes(args.get(4)));
    statusRequestCompleted = true;
  }
  
  public boolean responseComplete () {
    return statusRequestCompleted;
  }
  
  public String toString () {
    return DESCRIPTION;
  }
    
}
